package cn.iocoder.yudao.module.iot.service.formula;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.mock.mockito.MockBean;



import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.iot.controller.admin.formula.vo.*;
import cn.iocoder.yudao.module.iot.dal.dataobject.formula.FormulaDO;
import cn.iocoder.yudao.module.iot.dal.mysql.formula.FormulaMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;


import org.springframework.context.annotation.Import;

import javax.annotation.Resource;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.iot.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link FormulaServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(FormulaServiceImpl.class)
public class FormulaServiceImplTest extends BaseDbUnitTest {

    @Resource
    private FormulaServiceImpl formulaService;

    @Resource
    private FormulaMapper formulaMapper;

    @Test
    public void testCreateFormula_success() {
        // 准备参数
        FormulaSaveReqVO createReqVO = randomPojo(FormulaSaveReqVO.class).setId(null);

        // 调用
        Long formulaId = formulaService.createFormula(createReqVO);
        // 断言
        assertNotNull(formulaId);
        // 校验记录的属性是否正确
        FormulaDO formula = formulaMapper.selectById(formulaId);
        assertPojoEquals(createReqVO, formula, "id");
    }

    @Test
    public void testUpdateFormula_success() {
        // mock 数据
        FormulaDO dbFormula = randomPojo(FormulaDO.class);
        formulaMapper.insert(dbFormula);// @Sql: 先插入出一条存在的数据
        // 准备参数
        FormulaSaveReqVO updateReqVO = randomPojo(FormulaSaveReqVO.class, o -> {
            o.setId(dbFormula.getId()); // 设置更新的 ID
        });

        // 调用
        formulaService.updateFormula(updateReqVO);
        // 校验是否更新正确
        FormulaDO formula = formulaMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, formula);
    }

    @Test
    public void testUpdateFormula_notExists() {
        // 准备参数
        FormulaSaveReqVO updateReqVO = randomPojo(FormulaSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> formulaService.updateFormula(updateReqVO), FORMULA_NOT_EXISTS);
    }

    @Test
    public void testDeleteFormula_success() {
        // mock 数据
        FormulaDO dbFormula = randomPojo(FormulaDO.class);
        formulaMapper.insert(dbFormula);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbFormula.getId();

        // 调用
        formulaService.deleteFormula(id);
       // 校验数据不存在了
       assertNull(formulaMapper.selectById(id));
    }

    @Test
    public void testDeleteFormula_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> formulaService.deleteFormula(id), FORMULA_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetFormulaPage() {
       // mock 数据
       FormulaDO dbFormula = randomPojo(FormulaDO.class, o -> { // 等会查询到
           o.setName(null);
           o.setFormulaCode(null);
           o.setFormula(null);
           o.setResultType(null);
           o.setMachineId(null);
           o.setRemark(null);
           o.setIsEnable(null);
           o.setCreateTime(null);
       });
       formulaMapper.insert(dbFormula);
       // 测试 name 不匹配
       formulaMapper.insert(cloneIgnoreId(dbFormula, o -> o.setName(null)));
       // 测试 formulaCode 不匹配
       formulaMapper.insert(cloneIgnoreId(dbFormula, o -> o.setFormulaCode(null)));
       // 测试 formula 不匹配
       formulaMapper.insert(cloneIgnoreId(dbFormula, o -> o.setFormula(null)));
       // 测试 resultType 不匹配
       formulaMapper.insert(cloneIgnoreId(dbFormula, o -> o.setResultType(null)));
       // 测试 machineId 不匹配
       formulaMapper.insert(cloneIgnoreId(dbFormula, o -> o.setMachineId(null)));
       // 测试 remark 不匹配
       formulaMapper.insert(cloneIgnoreId(dbFormula, o -> o.setRemark(null)));
       // 测试 isEnable 不匹配
       formulaMapper.insert(cloneIgnoreId(dbFormula, o -> o.setIsEnable(null)));
       // 测试 createTime 不匹配
       formulaMapper.insert(cloneIgnoreId(dbFormula, o -> o.setCreateTime(null)));
       // 准备参数
       FormulaPageReqVO reqVO = new FormulaPageReqVO();
       reqVO.setName(null);
       reqVO.setFormulaCode(null);
       reqVO.setFormula(null);
       reqVO.setResultType(null);
       reqVO.setMachineId(null);
       reqVO.setRemark(null);
       reqVO.setIsEnable(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<FormulaDO> pageResult = formulaService.getFormulaPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbFormula, pageResult.getList().get(0));
    }

}